## IdeDebuggerBreakpoints IdeDebuggerBreakpoints |

## Functions

GFile * | ide_debugger_breakpoints_get_file ()
IdeDebuggerBreakMode | ide_debugger_breakpoints_get_line_mode ()
IdeDebuggerBreakpoint * | ide_debugger_breakpoints_get_line ()
void | ide_debugger_breakpoints_foreach ()

## Properties

GFile * | file | Read / Write / Construct Only

## Signals

void | changed | Run Last

## Types and Values

#define | IDE_TYPE_DEBUGGER_BREAKPOINTS
| IdeDebuggerBreakpoints

## Object Hierarchy

        GObject
        ╰── IdeDebuggerBreakpoints

## Description

The IdeDebuggerBreakpoints provides a convenient container for breakpoints about a single file. This is useful for situations like the document gutter where we need very fast access to whether or not a line has a breakpoint set during the rendering process.

At it's core, this is a sparse array as rarely do we have more than one cacheline of information about breakpoints in a file.

This object is controled by the IdeDebuggerManager and will modify the breakpoints as necessary by the current debugger. If no debugger is active, the breakpoints are queued until the debugger has started, and then synchronized to the debugger process.

## Functions

### ide_debugger_breakpoints_get_file ()

    GFile *
    ide_debugger_breakpoints_get_file (IdeDebuggerBreakpoints *self);

Gets the "file" property, which is the file that breakpoints within this container belong to.

#### Parameters

self | An IdeDebuggerBreakpoints |

#### Returns

a GFile.

[transfer none]

Since: 3.32

### ide_debugger_breakpoints_get_line_mode ()

    IdeDebuggerBreakMode
    ide_debugger_breakpoints_get_line_mode
                                   (IdeDebuggerBreakpoints *self,
                                    guint line);

### ide_debugger_breakpoints_get_line ()

    IdeDebuggerBreakpoint *
    ide_debugger_breakpoints_get_line (IdeDebuggerBreakpoints *self,
                                       guint line);

Gets the breakpoint that has been registered at a given line, or `NULL` if no breakpoint is registered there.

#### Parameters

self | An IdeDebuggerBreakpoints |
line | The line number |

#### Returns

An IdeDebuggerBreakpoint or `NULL`.

[nullable][transfer none]

Since: 3.32

### ide_debugger_breakpoints_foreach ()

    void
    ide_debugger_breakpoints_foreach (IdeDebuggerBreakpoints *self,
                                      GFunc func,
                                      gpointer user_data);

Call `func` for every IdeDebuggerBreakpoint in `self` .

#### Parameters

self | a IdeDebuggerBreakpoints |
func | a GFunc to call. | [scope call][closure user_data]
user_data | user data for `func` |

Since: 3.32

## Types and Values

### IDE_TYPE_DEBUGGER_BREAKPOINTS

    #define IDE_TYPE_DEBUGGER_BREAKPOINTS (ide_debugger_breakpoints_get_type())

### IdeDebuggerBreakpoints

    typedef struct _IdeDebuggerBreakpoints IdeDebuggerBreakpoints;

## Property Details

### The `“file”` property

      “file”                     GFile *

The file for the breakpoints.

Owner: IdeDebuggerBreakpoints

Flags: Read / Write / Construct Only

## Signal Details

### The `“changed”` signal

    void
    user_function (IdeDebuggerBreakpoints *idedebuggerbreakpoints,
                   gpointer                user_data)

Flags: Run Last